// Problem   : D (Spring tournament 2007)
// Generator : Igor V. Burago

#include <cstdio>
#include <cstdlib>
#include <cmath>

int Random(int RangeMin, int RangeMax)
{
  return RangeMin + (rand() + RAND_MAX*rand()) % (RangeMax - RangeMin + 1);
}

const int MAX_N = 100000;
const int MAX_N_SQ = 10000;

int main(int argc, char *argv[])
{
  if (argc <= 2)
    return 1;

  freopen("input.txt", "wt", stdout);

  int N, K;
  unsigned RandStart;

  sscanf(argv[1], "%u", &RandStart);
  srand(RandStart);

  if (argc > 3)
  {
    sscanf(argv[2], "%d", &N);
    sscanf(argv[3], "%d", &K);

    printf("%d ", Random(1, N));
    printf("%d\n", Random(1, K));
  }
  else
  {
    sscanf(argv[2], "%d", &K);
    
    int i, SqrsCount, SqrsLength = (int)sqrt((double)MAX_N_SQ) + 1;
    int *Sqrs = new int[SqrsLength];

    SqrsCount = 0;
    for (i = 0; i < SqrsLength; i++)
      Sqrs[SqrsCount++] = i * i;

    N = 0;
    for (i = 0; i < K; i++)
    {
      int S = Sqrs[Random(1, SqrsCount - 1)];
      N += S;
      if (N > MAX_N)
      {
        N -= S;
        K = i + 1;
        break;
      }
      // printf("%d ", S);
    }
    // printf("\n");

    delete [] Sqrs;

    printf("%d %d\n", N, K);
  }
 
  return 0;
}