// Problem  : D (Spring tournament 2007)
// Solution : Igor V. Burago

#include <cstdio>
#include <cstring>
#include <climits>
#include <cmath>
#include <cassert>

int main()
{
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);

  int N, K;
  scanf("%d%d", &N, &K);
  assert(1 <= N && N <= 100000);
  assert(1 <= K && K <= 1000);

  int *Sqrs, *Count, *From;
  int SqrsLength = (int)sqrt((double)N) + 1;

  Sqrs = new int[SqrsLength];
  Count = new int[N + 1];
  From = new int[N + 1];

  memset(From, 0, sizeof(*From) * (N + 1));
  memset(Count, 0x7f, sizeof(*Count) * (N + 1));

  int i, j, SqrsCount = 0;
  for (i = 0; i < SqrsLength; i++)
    Count[Sqrs[SqrsCount++] = i * i] = 1;
  for (i = 1; i <= N; i++)
    for (j = 1; j < SqrsCount; j++)
    {
      int idx = i - Sqrs[j];
      if (idx >= 0 && Count[idx] < K && Count[i] > Count[idx] + 1)
      {
        Count[i] = Count[idx] + 1;
        From[i] = idx;
      }
    }

  if (Count[N] > K)
    puts("NO");
  else
  {
    puts("YES");
    for (int num = N; num != 0; num = From[num])
      printf("%0.0f ", sqrt((double)num - From[num]));
  }

  delete [] Sqrs;
  delete [] Count;
  delete [] From;

  return 0;
}